#!/bin/python3
import gzip
import sys
import shutil
import os

if len(sys.argv) == 3:
    # execute mode
    with gzip.open(sys.argv[2], "r") as f:
        contents = f.read()
    contents = ''.join([chr(x) for x in contents])
    length = len(contents)
    tape = [0] * 30000
    ip = 0
    tp = 0
    while ip < length:
        if contents[ip] == '+':
            tape[tp] += 1
            tape[tp] %= 256
        elif contents[ip] == '-':
            tape[tp] -= 1
            if tape[tp] < 0:
                tape[tp] = 255
        elif contents[ip] == '>':
            tp += 1
        elif contents[ip] == '<':
            tp -= 1
        elif contents[ip] == '[':
            if tape[tp] == 0:
                brackets = 1
                while brackets != 0:
                    if contents[ip] == '[':
                        brackets += 1
                    elif contents[ip] == ']':
                        brackets -= 1
                    ip += 1
                ip -= 1
        elif contents[ip] == ']':
            if tape[tp] != 0:
                brackets = 1
                while brackets != 0:
                    if contents[ip] == '[':
                        brackets -= 1
                    elif contents[ip] == ']':
                        brackets == 1
                    ip -= 1
        elif contents[ip] == '.':
            print(chr(tape[tp]), end="")
        elif contents[ip] == ',':
            tape[tp] = ord(os.read(0, 1))
        ip += 1
else:
    with open(sys.argv[2], "rb") as f:
        with gzip.open(sys.argv[3], "wb") as f_out:
            shutil.copyfileobj(f, f_out)