-- // Code by SoundOfSpouting#6980 (UID: 151149148639330304)
import Data.List
import System.Directory
import System.Environment
import System.Exit
import System.IO
import System.IO.Unsafe
import System.Process

eval = unsafePerformIO -- idiomatic

genAsmInsts _ []     []            = ""
genAsmInsts n os     (('[', 1):is) = asmInst '[' n <> genAsmInsts (n+1) (n:os) is
genAsmInsts n (o:os) ((']', 1):is) = asmInst ']' o <> genAsmInsts n     os     is
genAsmInsts n os     ((ins, c):is) = asmInst ins c <> genAsmInsts n     os     is

asmInst '>' c = "    add r1, " <> show c <> "\n"
asmInst '<' c = "    sub r1, " <> show c <> "\n"
asmInst '+' c = "    amp r1, " <> show c <> "\n"
asmInst '-' c = "    smp r1, " <> show c <> "\n"
asmInst ',' c =                        (unlines $ replicate c "    in r2" ) <> "    sto r1, r2\n"
asmInst '.' c = "    movf r2, r1\n" <> (unlines $ replicate c "    out r2")
asmInst '[' n = "movf r2, r1 \njz r2, %loop_end_"   <> show n <> "\n@loop_start_" <> show n <> "\n"
asmInst ']' n = "movf r2, r1\njnz r2, %loop_start_" <> show n <> "\n@loop_end_"   <> show n <> "\n"

genAsm = genAsmInsts 0 [] . map (\g @ (x:_) -> (x, length g)) . groupBy (\x y -> x `elem` "><+-,." && x == y)

main = do let (args, progName) = (eval getArgs, eval getProgName)

          let usageWarning = "Usage:\n    " <> progName <> " -c [INFILE] [OUTFILE]\n    " <> progName <> " -r [FILE]\n"
          let installationWarning cmd = "Could not find command \"" <> cmd <> "\"!\n" <> progName <> " requires asm2bf v1.5.4a to be installed!\n"

          let exitError e = putStr e >> exitWith (ExitFailure 1)

          let assertCommandExists cmd = if eval (waitForProcess ph) == ExitSuccess then return ()
                                        else exitError $ installationWarning cmd
                                        where (_, _, _, ph) = eval $ createProcess (proc "which" [cmd]){ std_out = CreatePipe }

          let executeCommand       cmd args = eval $ assertCommandExists cmd >> createProcess (proc cmd args){ std_in = CreatePipe,    std_out = CreatePipe, std_err = CreatePipe }
          let executeCommandIn hin cmd args = eval $ assertCommandExists cmd >> createProcess (proc cmd args){ std_in = UseHandle hin, std_out = CreatePipe, std_err = CreatePipe }
          let getCommandOutput (_, Just hout, _, _) = eval $ hGetContents hout

          case () of _
                       | length args >= 3 && args !! 0 == "-c" -> withFile (args !! 1) ReadMode (\sourceFile -> do withFile ("temp.asm") WriteMode $ flip hPutStr $ genAsm $ getCommandOutput $ executeCommandIn sourceFile "bfstrip" []
                                                                                                                   putStr $ getCommandOutput $ executeCommand "bfmake" ["temp.asm"]
                                                                                                                   renameFile "temp.b" $ args !! 2)
                       | length args >= 2 && args !! 0 == "-r" -> putStr $ getCommandOutput $ executeCommandIn stdin "bfi" [args !! 1]
                       | True                                  -> exitError usageWarning
